﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.events.MouseEvent;
	import flash.display.DisplayObject;
   	import flash.events.*;
   	import flash.display.MovieClip;
	import flash.text.TextField;
	
	public class Suiveur extends Sprite
	{
		private var mover:Sprite;
		private var i:Number = 0;
		private var c:Boolean = true;
		private var a:Number = 1;
		private var color:Number = Math.random()*0xffffff;
		private var r:Number = 0;
		private var s:Boolean = true;
		private var f:Number = 0;
		private var u:Boolean = true;
		private var l:Boolean = true;
		private var n:Number = 1;
		private var m:Number = 0;
		private var p:Boolean = true;
		
		public function Suiveur()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			mover = new Sprite();
			addChild(mover);
			addEventListener(Event.ENTER_FRAME, enterHandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
		}
		private function enterHandler(e:Event):void
		{
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyHandlerRight);
			mover.x+= -(mouseX-stage.stageWidth/2)/10;
			mover.y+= -(mouseY-stage.stageHeight/2)/10;
			drawElem(i++);
			
		}
		private function drawElem(nbr:Number):void
		{
			var elem:Sprite = new Sprite();
			elem.name = "ch"+i;
			//trace(m);
			if(m == 0){
				elem.graphics.beginFill(color,a);
			}else if(m >= 1 && m <=11){
				elem.graphics.lineStyle(m,color, a);
			}else{
				elem.graphics.lineStyle(Math.random()*10,color, a);
			}
						
			// forme #1		cercles
			if (f == 0){
				elem.graphics.drawCircle(mouseX-mover.x,mouseY-mover.y,Math.sin(n*i*Math.PI/180)*70);
			}
			// forme #2		carre
			if (f == 1){
				elem.graphics.drawRect((mouseX-mover.x) - (Math.sin(n*i*Math.PI/180)*70)/2,(mouseY-mover.y) - (Math.sin(i*Math.PI/180)*70)/2,Math.sin(n*i*Math.PI/180)*70,Math.sin(i*Math.PI/180)*70);
			}
			// forme #3		ligne 1
			if (f == 2){
				elem.graphics.drawRect((mouseX-mover.x) - (Math.sin(n*i*Math.PI/180)*70)/2,(mouseY-mover.y),Math.sin(n*i*Math.PI/180)*70,n);
			}
			// forme #4		lignes 2
			if (f == 3){
				elem.graphics.lineStyle(Math.sin(i*Math.PI/180)*20,color, a);
				elem.graphics.moveTo((mouseX-mover.x)-100,(mouseY-mover.y)+r);
				elem.graphics.lineTo((mouseX-mover.x)+100,(mouseY-mover.y)-r);
			}			
			
			elem.graphics.endFill();
			
			if (u == false){
				elem.addEventListener(Event.ENTER_FRAME,fadeOut);
			}else{
				elem.removeEventListener(Event.ENTER_FRAME,fadeOut);
			}
			mover.addChild(elem);
		}
		private function clickHandler(e:MouseEvent):void
		{
			c = !c;
			l = !l;
			//trace(c);
			if (c == true){
				addEventListener(Event.ENTER_FRAME, enterHandler);
			}else if( c == false){
				removeEventListener(Event.ENTER_FRAME, enterHandler);
				addEventListener(Event.ENTER_FRAME,enterHandler2);
			}
		}
		
		private function enterHandler2(e:Event):void
		{
			mover.x+= -(mouseX-stage.stageWidth/2)/15;
			mover.y+= -(mouseY-stage.stageHeight/2)/15;
		}
		
		private function keyHandlerRight (event:KeyboardEvent):void
		{
			//trace(event.keyCode);
			//Change color		touche "y"
			if (event.keyCode == 89){
				a = Math.random()*1;
			}
			//change color		touche "x"
			if (event.keyCode == 88){
				color = Math.random()*0xffffff;
			}
			//change radius		touche "c"
			if (event.keyCode == 67){
				//trace(r);
				if (r <= 200 && s == true){
					r +=20;
					if (r == 200){
						s = !s;
					}
				}
				if (s == false){
					r -= 20;
					if (r == 0){
						s = !s;
					}
				}
			}
			//change forms		touche "v"
			if (event.keyCode == 86){
				f += 1;
				if (f == 4){
					f = 0;
				}
			}
			//clear all		touche "b"
			if (event.keyCode == 66){
				while(mover.numChildren>0){
					mover.removeChildAt(0);
				}
			}
			//change speed		touche "n"
			if (event.keyCode == 78){
				if (n <= 13 && s == true){
					n +=1;
					if (n == 13){
						s = !s;
					}
				}
				if (s == false){
					n -= 1;
					if (n == 1){
						s = !s;
					}
				}
			}
			//Change lineStyle		touche "m"
			if (event.keyCode == 77){
				
				if(m <= 11){
					m++;
				}else{
					m = 0;
				}
			}
			//See the whole image
			/*if (event.keyCode == 65){
				if (p == true){
					//trace(p);
					removeEventListener(Event.ENTER_FRAME, enterHandler);
					removeEventListener(Event.ENTER_FRAME, enterHandler2);
					stage.removeEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
					removeEventListener(Event.ADDED_TO_STAGE, addedHandler);
					
					if (mover.width > mover.height){
						var w:Number = 600/mover.width;
						mover.width = w;
						mover.x = 300;
						mover.y = 300;
					}else if ( mover.width < mover.height){
						mover.height = 600;
						mover.x = 300;
						mover.y = 300;
					}
					
					
					//mover.height = stage.height;
					trace(mover.width + " : " + mover.height);
					trace(stage.width);
					p = !p;
				}
				else{
					//trace(p);
					addEventListener(Event.ENTER_FRAME, enterHandler);
					addEventListener(Event.ENTER_FRAME, enterHandler2);
					stage.addEventListener(MouseEvent.MOUSE_DOWN, clickHandler);
					addEventListener(Event.ADDED_TO_STAGE, addedHandler);
					p = !p;
					//mover.width = mover.width*3;
					//mover.height = mover.height*3;
				}
				
			}*/
			
		}
		
		
		private function fadeOut(e:Event):void{
			if (l == false){
				e.currentTarget.x += Math.random()*2;
				e.currentTarget.y += Math.random()*10;
			}else{
				e.currentTarget.x = 5;
				e.currentTarget.y = 10;
				//e.currentTarget.alpha-=0.009;
			}
			
			if(e.currentTarget.alpha<=0){
				if(mover.getChildByName(e.currentTarget.name)!=null){
					e.currentTarget.removeEventListener(Event.ENTER_FRAME,fadeOut);
					mover.removeChild(mover.getChildByName(e.currentTarget.name));
				}
			}
		}
		
	}
}